.686p
.model  flat, stdcall
option Casemap :None    
.nolist
include windows.inc

uselib  MACRO   libname
    include     libname.inc
    includelib  libname.lib
ENDM
uselib user32
uselib kernel32
uselib comctl32
uselib gdi32

inv equ invoke
.list
.data
ClassName       DB "StdWindow",0
szAppName       DB "Test",0
wc WNDCLASS <CS_HREDRAW or CS_VREDRAW,WndProc,0,0,0,0,0,COLOR_WINDOW+1,0,ClassName>

.data?
hInst   dd ?
hWindow dd ?
hWin    dd ?
hwindow dd ?
hdc     dd ? 
message MSG <>

.code
Program:
    inv GetModuleHandle, 0
    mov hInst,eax
    mov wc.hInstance,eax   ; save for later
    inv LoadIcon, 0, IDI_APPLICATION
    mov wc.hIcon,eax
    inv LoadCursor, 0, IDC_ARROW
    mov wc.hCursor,eax
    inv RegisterClass, addr wc
    inv CreateWindowEx,WS_EX_CLIENTEDGE,addr ClassName,addr szAppName,WS_OVERLAPPEDWINDOW,
           CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,0,0,hInst,0
    mov hWindow,eax
    inv ShowWindow, hWindow, SW_SHOWNORMAL
    inv UpdateWindow, hWindow
    .repeat
        inv GetMessage,addr message,0,0,0
        .break .if !eax
        inv TranslateMessage,addr message
        inv DispatchMessage,addr message
    .until 0
    inv ExitProcess,message.wParam


DIBX struct
   dib  dword ? ; handle to dib
   bits dword ? ; address of start of bit info
   bih  BITMAPINFOHEADER <> 
DIBX ends

.data?
dibh1  DIBX <> ; main back buffer dib (device independant bitmap) (hidden buffer 1)
dibmc  DIBX <> ; mouse cursor dib, 100 x 100

crect RECT <>
mwidth  equ crect.right  ; total width of client rectangle in pixels
mheight equ crect.bottom ; total height in pixels

.code
MakeDibSection proc uses edi adib,btmw,btmh ; create dib section. adib=address of DIBX structure
                                      ; btmw is the width, btmh is the height
    mov edi,adib
    assume edi:ptr DIBX
    mov eax,[edi].dib
    .if eax
        inv DeleteObject,eax    ; delete old dib
    .endif
    mov ecx,sizeof DIBX ; clear out any old data
    mov eax,0
    rep stosb
    mov edi,adib
    mov eax,btmw
    mov [edi].bih.biWidth,eax  ; set width and height in bitmapinfoheader
    mov eax,btmh
    neg eax
    mov [edi].bih.biHeight,eax
    mov [edi].bih.biSize,sizeof BITMAPINFOHEADER
    mov [edi].bih.biPlanes,1
    mov [edi].bih.biBitCount,32
    mov [edi].bih.biCompression,BI_RGB
    lea eax,[edi].bits
    lea edx,[edi].bih
    inv CreateDIBSection,0,edx,DIB_RGB_COLORS,eax,0,0
    mov [edi].dib,eax
    assume edi:nothing
	ret
MakeDibSection endp

.data
fmtx6 db "%li %li %li %li %li %li",0
fmtx1 db " %li "
.data?
buffx db 1024 dup (?)
.code
WndProc Proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
    local tdc,ccnt,cloc,rloc
    .if uMsg==WM_CREATE
        mov eax,hWnd
        mov hWin,eax
        inv GetClientRect,hWin,addr crect    ; get the size needed for the bitmap
        inv MakeDibSection,addr dibh1,mwidth,mheight
        inv MakeDibSection,addr dibmc,100,100
        mov eax,0ffffbfh     ; fill hidden screen buffer with a color
        mov ecx,mwidth
        imul ecx,mheight
        push edi
        mov edi,dibh1.bits
        rep stosd
        pop edi
        inv GetDC,hWin
        mov hdc,eax
        inv CreateCompatibleDC,hdc
        mov tdc,eax
        inv ReleaseDC,hWin,hdc
        inv SelectObject,tdc,dibh1.dib
        inv SetBkMode,tdc,TRANSPARENT
        mov ccnt,0
        mov rloc,0
        mov cloc,0
        .repeat
            inv wsprintf,addr buffx,addr fmtx1,ccnt
            ;inv DrawText,tdc,addr buffx,-1,addr tt,0
            inv TextOut,tdc,cloc,rloc,addr buffx,eax
            add ccnt,1
            add cloc,44
            mov eax,mwidth
            .if cloc  > eax
                add rloc,17
                mov cloc,0
                mov eax,mheight
                .break .if rloc > eax
            .endif
        .until 0
        inv DeleteDC,tdc
        call UpdateScreen
    .elseif uMsg==WM_PAINT
        call UpdateScreen 
    .elseif uMsg == WM_SETCURSOR
        call SetMouseCursorImage
    .elseif uMsg==WM_CLOSE
        ; do cleanup here
    .elseif uMsg==WM_DESTROY
        inv PostQuitMessage,0
        mov eax,wParam
        jmp WndRet
    .endif
    inv DefWindowProc, hWnd, uMsg, wParam, lParam
WndRet:
    ret
WndProc EndP

UpdateScreen proc
    inv GetDC,hWin
    mov hdc,eax
    inv SetDIBitsToDevice,hdc,0,0,mwidth,mheight,0,0,0,mheight,dibh1.bits,addr dibh1.bih,DIB_RGB_COLORS
    inv ReleaseDC,hWin,hdc
	ret
UpdateScreen endp

.data?
smcx      dd ? ; current x,y of cursor
smcy      dd ?
prevmcx   dd ? ; last place we drew the cursor
prevmcy   dd ?
prevmw    dd ? ; width of saved image
prevmh    dd ? ; height of saved image
smnumlines  dd ? ; scratch number of lines to do
smwidthtodo dd ? ; scratch number of bytes to do across image
mwidth4   dd ? ; bytes in a line
startcurs dd ? ; first byte of cursor to use
ccolor    dd ? ; cursor color, currently black
flag1     dd ?
restorems dd ?

.code
SetMouseCursorImage:

    
    .if restorems   ; do we have an image to restore from?
        inv GetDC,hWin  ; yes, remove our cursor from the screen
        mov hdc,eax
methodx = 2  ; 1 or 2
if methodx eq 1
        mov ecx,mheight
        sub ecx,prevmcy
        sub ecx,prevmh        
        inv SetDIBitsToDevice,hdc,prevmcx,prevmcy,prevmw,prevmh,prevmcx,ecx,0,mheight,dibh1.bits,addr dibh1.bih,DIB_RGB_COLORS    
elseif methodx eq 2
        inv SetDIBitsToDevice,hdc,prevmcx,prevmcy,prevmw,prevmh,prevmcx,0,0,100,dibh1.bits,addr dibh1.bih,DIB_RGB_COLORS    
endif
        inv ReleaseDC,hWin,hdc
        inc flag1
    .endif

    inv GetCursorPos,addr smcx         ; maybe do on wm_mousemove or wm_ncmousemove
    inv ScreenToClient,hWin,addr smcx  ; maybe get conversion factors on resize and start
    inv SetCursor,0 ; suppress windows cursor

    mov eax,smcx
    mov edx,smcy
    .if sdword ptr eax < 0 || eax >= mwidth || edx < 0 || edx >= mheight
        mov restorems,0 ; already restored, don't do again
        ret
    .endif

    pusha   ; need lots of registers

    mov eax,smcx    ; current mouse x,y
    mov edx,smcy
    mov prevmw,100  ; assume full width and height
    mov prevmh,100
    sub eax,50      ; find upper left corner
    sub edx,50

    .if sdword ptr eax < 0  
        add prevmw,eax  ; subtract out amount to skip
        mov eax,0       ; start at left of screen
    .endif
    .if sdword ptr edx < 0
        add prevmh,edx
        mov edx,0
    .endif
    push eax
    add eax,100     ; check for overlap of right edge
    .if eax>mwidth
        sub eax,mwidth
        sub prevmw,eax  ; amount to do
    .endif
    pop eax
    
    push edx
    add edx,100
    .if edx>mheight
        sub edx,mheight
        sub prevmh,edx
    .endif
    pop edx

    mov prevmcx,eax
    mov prevmcy,edx
    shl eax,2       ; * 4 bytes/pixel
    shl edx,2
    
    imul edx,mwidth     ; pixels to skip on top
    add edx,eax         ; pixels to skip on left
    
    mov esi,dibh1.bits  ; source
    add esi,edx         ; start of data
    mov edi,dibmc.bits  ; destination 2 (image overlaid with mouse)
    
    mov eax,prevmw      ; number of pixels to copy x-wise
    shl eax,2           ; number of bytes
    mov smwidthtodo,eax
    
    mov eax,mwidth
    shl eax,2
    mov mwidth4,eax

    mov eax,prevmh
    mov smnumlines,eax  ; number of lines to do
    .repeat
        mov ebp,0       ; offsets from input and output
        .repeat
            mov eax,[esi+ebp]
            mov [edi+ebp],eax   ; input data
                ; do fake alpha
                mov ccolor,0    ; cursor color
                mov ebx,256
                mov ecx,128 ; simulate 50% alpha
                mov eax,ecx ; save alpha
                sub ebx,ecx ; 1-alpha
                mov edx,22  ; fake blue part for test
                movzx eax,byte ptr [esi+ebp] ; blue part of image
                imul dx,bx      ; * (1-alpha)
                imul ax,cx      ; * alpha
                add ah,dh   ; = (x/256) + (y/256)
                mov [edi+ebp],ah
            add ebp,4
        .until ebp==smwidthtodo
        add esi,mwidth4
        add edi,400
        dec smnumlines
    .until zero?

    inv GetDC,hWin
    mov hdc,eax
    
method = 2  ; 1 or 2
if method eq 1
    mov ecx,100         ; size of the dib
    sub ecx,prevmh      ; number of scan lines to show, starting from the top
    inv SetDIBitsToDevice,hdc,prevmcx,prevmcy,prevmw,prevmh,0,ecx,0,100,dibmc.bits,addr dibmc.bih,DIB_RGB_COLORS
elseif method eq 2
    inv SetDIBitsToDevice,hdc,prevmcx,prevmcy,prevmw,prevmh,0,0,0,100,dibmc.bits,addr dibmc.bih,DIB_RGB_COLORS
endif

    inv ReleaseDC,hWin,hdc

    mov restorems,1 ; have restore buffer

    inv wsprintf,addr buffx,addr fmtx6,prevmcx,prevmcy,prevmw,prevmh,mwidth,mheight
    inv SetWindowText,hWin,addr buffx
    popa        
	ret


End Program